/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"
#include "TFT.h"

#define SWAP(a, b)  { a ^= b; b ^= a; a ^= b; }

unsigned int tftID ;
unsigned int scrollbugfix = 0 ;

/* following vairables were originally
 * private member of the TFT class
*/
static int screensize_X = 240 ;
static int screensize_Y = 320 ;
// static int cur_x ;
// static int cur_y ;
// static int win_x1 ;
// static int win_x2 ;
// static int win_y1 ;
// static int win_y2 ;
static int orientation ;
// static int topfixedareasize ;
// static int scrollareasize ;
// static int useNOP = 0 ;
static int usefastwindow = 0 ;
static int fastwindowready = 0 ;
// static int is18bit = 0 ;
// static int isBGR = 0 ;
static int oriented_width=0 ;
static int oriented_height=0 ;
static int fontzoomver=1 ;
static int fontzoomhor=1 ;
static int mipistd = 0 ;
static unsigned short _foreground = 0xFFFF ;
static unsigned short _background = 0x0000 ;

// text char location
static int char_x = 0 ;
static int char_y = 0 ;

static unsigned char *font ;
static int fontoffset ; // bytes / char (short)
static int fonthor ;   // hor size of font (char)
static int fontvert ;  // ver size of font (char)
static int fontbpl ;  // bytes per line (char)
static unsigned char firstch = 32 ; // first ascii code present in font array (usually 32)
static unsigned char lastch = 127 ; // last ascii code present in font array (usually 127)
static int auto_up ; // autoupdate flag for LCD
static int fontprop ;

extern volatile int spi_done_flag  ;

static void wr_cmd8(uint8_t cmd)
{
    TFT_DC_Write(0) ; /* command */
//    SPI_ClearRxBuffer() ;
    SPI_WriteTxData(cmd) ;
    while(spi_done_flag == 0) {
    } 
    spi_done_flag = 0 ;
//    SPI_ClearRxBuffer() ;

    TFT_DC_Write(1) ; 

}

static void wr_data8(uint8_t data)
{
//    SPI_ClearRxBuffer() ;    
    SPI_WriteTxData(data) ;    
    while(spi_done_flag == 0) {
    } 
    spi_done_flag = 0 ;
//    SPI_ClearRxBuffer() ;
}

#if 0
static void wr_cmd16(unsigned short cmd)
{
    TFT_DC_Write(0) ;
    SPI_ClearRxBuffer() ;
    SPI_WriteTxData(cmd >> 8) ; 
    SPI_WriteTxData(cmd & 0xFF) ;
    while(2 != SPI_GetRxBufferSize()) {
    }
    SPI_ClearRxBuffer() ;
    TFT_DC_Write(1) ;
}
#endif

static void wr_data16(unsigned short data)
{
//    SPI_ClearRxBuffer() ;    
    SPI_WriteTxData(data >> 8) ;
    SPI_WriteTxData(data & 0xFF) ;
    while(spi_done_flag == 0) {
    } 
    spi_done_flag = 0 ;
//    SPI_ClearRxBuffer() ;
}

static void wr_gram(unsigned short data)
{
//    SPI_ClearRxBuffer() ;
    SPI_WriteTxData(data >> 8) ;
    SPI_WriteTxData(data & 0xFF) ;      
    while(spi_done_flag == 0) {
    } 
    spi_done_flag = 0 ;
//    SPI_ClearRxBuffer() ;
}

static void wr_gramN(unsigned short data, unsigned int count)
{
    SPI_ClearRxBuffer() ;
    if ((data >> 8)==(data&0xFF)) {
        count <<=1 ;
        while(count) {
            SPI_WriteTxData(data) ;
    while(spi_done_flag == 0) {
    } 
    spi_done_flag = 0 ;
//            SPI_ClearRxBuffer() ;
            count-- ;
        }
    } else {
        while(count) {
            SPI_WriteTxData(data >> 8) ; // write MSB
            SPI_WriteTxData(data&0xFF) ; // write LSB
//            SPI_WriteTxData(data >> 8) ; // write MSB
    while(spi_done_flag == 0) {
    } 
    spi_done_flag = 0 ;
//            SPI_ClearRxBuffer() ;
            count-- ;
        }
    }
}

static void wr_grambuf(unsigned short *data, unsigned int length)
{
    SPI_ClearRxBuffer() ;
    while(length) {
        SPI_WriteTxData((*data) >> 8) ; // write MSB
        SPI_WriteTxData((*data)&0xFF) ; // write LSB
//        SPI_WriteTxData((*data) >> 8) ; // write MSB
    while(spi_done_flag == 0) {
    } 
    spi_done_flag = 0 ;

//        SPI_ClearRxBuffer() ;
        data++ ;
        length-- ;
    }
}

void TFT_set_width(int width)
{
    oriented_width = width ;
}

void TFT_set_height(int height)
{
    oriented_height = height ;
}

void TFT_BusEnable(int mode) 
{
    if (mode == 0) { /* disable */
        TFT_CS_Write(1) ;
    } else {
        TFT_CS_Write(0) ;
    }
}

void TFT_Init(void) 
{
    TFT_CS_Write(1) ;
    TFT_DC_Write(1) ;
    TFT_BL_Write(0) ;
     /* Start Initial Sequence ----------------------------------------------------*/
    TFT_CS_Write(0) ; /* bus enable */
    
    wr_cmd8(0xCB);  // POWER_ON_SEQ_CONTROL             
     wr_data8(0x39);
     wr_data8(0x2C);
     wr_data8(0x00);
     wr_data8(0x34);
     wr_data8(0x02);
     
    wr_cmd8(0xCF);  // POWER_CONTROL_B              
     wr_data8(0x00);
     wr_data8(0xC1);  // Applic Notes 81, was 83, C1 enables PCEQ: PC and EQ operation for power saving
     wr_data8(0x30);
     
     wr_cmd8(0xE8);  // DRIVER_TIMING_CONTROL_A               
     wr_data8(0x85);
     wr_data8(0x00);  // AN 10, was 01
     wr_data8(0x78);  // AN 7A, was 79
     
     wr_cmd8(0xEA);  // DRIVER_TIMING_CONTROL_B                    
     wr_data8(0x00);
     wr_data8(0x00);
     
     wr_cmd8(0xED);                     
     wr_data8(0x64);
     wr_data8(0x03);
     wr_data8(0x12);
     wr_data8(0x81);
     
     wr_cmd8(0xF7);  // PUMP_RATIO_CONTROL                   
     wr_data8(0x20);
     
     wr_cmd8(0xC0);                     // POWER_CONTROL_1
     wr_data8(0x23);  // AN 21, was 26
     
     wr_cmd8(0xC1);                     // POWER_CONTROL_2
     wr_data8(0x10);  // AN 11, was 11
     
     wr_cmd8(0xC5);                     // VCOM_CONTROL_1
     wr_data8(0x3E);  // AN 3F, was 35
     wr_data8(0x28);  // AN 3C, was 3E
     
     wr_cmd8(0xC7);                     // VCOM_CONTROL_2
     wr_data8(0x86);  // AN A7, was BE
     
    
     wr_cmd8(0xB1);                     // Frame Rate
     wr_data8(0x00);
     wr_data8(0x18);  // AN 1B, was 1B  1B=70hz             
     
     wr_cmd8(0xB6);                       // display function control, INTERESTING
     wr_data8(0x08);  // AN 0A, was 0A
     wr_data8(0x82);  // AN A2
     wr_data8(0x27);  // AN not present
  //   wr_data8(0x00);  // was present
     
     wr_cmd8(0xF2);                     // Gamma Function Disable
     wr_data8(0x00);  // AN 00, was 08
     
     wr_cmd8(0x26);                     
     wr_data8(0x01);                 // gamma set for curve 01/2/04/08
     
     wr_cmd8(0xE0);                     // positive gamma correction
     wr_data8(0x0F); 
     wr_data8(0x31); 
     wr_data8(0x2B); 
     wr_data8(0x0C); 
     wr_data8(0x0E); 
     wr_data8(0x08); 
     wr_data8(0x4E); 
     wr_data8(0xF1); 
     wr_data8(0x37); 
     wr_data8(0x07); 
     wr_data8(0x10); 
     wr_data8(0x03); 
     wr_data8(0x0E);
     wr_data8(0x09); 
     wr_data8(0x00);
     
     wr_cmd8(0xE1);                     // negativ gamma correction
     wr_data8(0x00); 
     wr_data8(0x0E); 
     wr_data8(0x14); 
     wr_data8(0x03); 
     wr_data8(0x11); 
     wr_data8(0x07); 
     wr_data8(0x31); 
     wr_data8(0xC1); 
     wr_data8(0x48); 
     wr_data8(0x08); 
     wr_data8(0x0F); 
     wr_data8(0x0C); 
     wr_data8(0x31);
     wr_data8(0x36); 
     wr_data8(0x0F);
     
     //wr_cmd8(0x34);                     // tearing effect off
     
     //wr_cmd8(0x35);                     // tearing effect on
      
  //   wr_cmd8(0xB7);                       // ENTRY_MODE_SET
  //   wr_data8(0x07);
  
    wr_cmd8(0x36);      // MEMORY_ACCESS_CONTROL (orientation stuff)
    wr_data8(0x48);
     
    wr_cmd8(0x3A);      // COLMOD_PIXEL_FORMAT_SET
    wr_data8(0x55);     // 16 bit pixel 

    wr_cmd8(0x13); // Nomal Displaymode
    
     wr_cmd8(0x11);                     // sleep out
     CyDelay(150) ; // wait_ms(150);
     
     wr_cmd8(0x29);                     // display on
     CyDelay(150) ; // wait_ms(150);   
     TFT_CS_Write(1) ;
    
    screensize_X = 240 ;
    screensize_Y = 320 ;
}

void TFT_BackLight(int mode) 
{
    TFT_BL_Write(mode) ;
}

void TFT_FastWindow(int mode)
{
    usefastwindow = mode ;
}

void TFT_window(int x, int y, int w, int h) 
{
    fastwindowready=0; // end raw/column going to be set to lower value than bottom-right corner
    wr_cmd8(0x2A);
    wr_data16(x);   //start column
    wr_data16(x+w-1);//end column

    wr_cmd8(0x2B);
    wr_data16(y);   //start page
    wr_data16(y+h-1);//end page
    
    wr_cmd8(0x2C);  //write mem, just send pixels color next
}

void TFT_pixel(int x, int y, unsigned short color) 
{
    if(usefastwindow) { //ili9486 does not like truncated 2A/2B cmds, at least in par mode
        if(fastwindowready) { //setting only start column/page does speedup, but needs end raw/column previously set to bottom-right corner
            wr_cmd8(0x2A);
            wr_data16(x);   //start column only
            wr_cmd8(0x2B);
            wr_data16(y);   //start page only
            wr_cmd8(0x2C);  //write mem, just send pixels color next
        } else {
            TFT_window(x,y,TFT_width()-x,TFT_height()-y); // set also end raw/column to bottom-right corner
            fastwindowready=1;
        }
    } else {
        TFT_window(x,y,1,1);
    }
  //  proto->wr_gram(color);   // 2C expects 16bit parameters
    wr_gram(color);
}

void TFT_WindowMax(void) 
{
    TFT_window(0, 0, oriented_width, oriented_height) ;
}

void TFT_window_pushpixel(unsigned short color) 
{
    wr_gram(color) ;
}

void TFT_window_pushpixelN(unsigned short color, unsigned int count) 
{
    wr_gramN(color, count) ;
}

void TFT_window_pushpixelbuf(unsigned short *color, unsigned int length)
{
    wr_grambuf(color, length) ;
}

void TFT_cls(void) 
{
    TFT_WindowMax() ;
    wr_gramN(_background, screensize_X * screensize_Y) ;
}

void TFT_set_orientation(int o) 
{
    orientation = o;
    wr_cmd8(0x36);
    switch (orientation) {
        case 0:// default, portrait view 0°
            if(mipistd) wr_data8(0x0A); // this is in real a vertical flip enabled, seems most displays are vertical flipped
            else wr_data8(0x48); //for some other ILIxxxx
            TFT_set_width(screensize_X);
            TFT_set_height(screensize_Y);
            break;
        case 1:// landscape view +90°
            if(mipistd) wr_data8(0x28); 
            else wr_data8(0x29);//for some other ILIxxxx
            TFT_set_width(screensize_Y);
            TFT_set_height(screensize_X);
            break;
        case 2:// portrait view +180°
            if(mipistd) wr_data8(0x09); 
            else wr_data8(0x99);//for some other ILIxxxx
            TFT_set_width(screensize_X);
            TFT_set_height(screensize_Y);
            break;
        case 3:// landscape view -90°
            if(mipistd) wr_data8(0x2B); 
            else wr_data8(0xF8);//for some other ILIxxxx
            TFT_set_width(screensize_Y);
            TFT_set_height(screensize_X);
            break;
    }
}

int TFT_sizeX(void) 
{
    return screensize_X ;
}

int TFT_sizeY(void) 
{
    return screensize_Y ;
}

int TFT_width() 
{
    return oriented_width ;
}

int TFT_height()
{
    return oriented_height ;
}

void TFT_foreground(unsigned short fg) 
{
    _foreground = fg ;
}

unsigned short TFT_get_foreground(void) 
{
    return _foreground ;
}

void TFT_background(unsigned short bg) 
{
    _background = bg ;
}

unsigned short TFT_get_background(void) 
{
    return _background ;
}

void TFT_circle(int x0, int y0, int r, unsigned short color) 
{
    int x ;
    int y ; 
    int err ;
    int e2 ;
    x = -r ;
    y = 0 ;
    err = 2 - 2*r ;
    do {
        TFT_pixel(x0-x, y0+y, color) ;
        TFT_pixel(x0+x, y0+y, color) ;
        TFT_pixel(x0+x, y0-y, color) ;
        TFT_pixel(x0-x, y0-y, color) ;
        e2 = err ;
        if (e2 <= y) {
            err += ++y * 2 + 1 ;
            if ((-x == y) && (e2 <= x)) {
                e2 = 0 ;
            }
        }
        if (e2 > x) {
            err += ++x * 2 + 1 ;
        }
    } while(x <= 0) ;
//    if (auto_up) copy_to_lcd() ;
}

void TFT_fillcircle(int x0, int y0, int r, unsigned short color) 
{
    int x, y, err, e2 ;
    int old_auto_up = auto_up ;
    if (auto_up) auto_up = 0 ;
    x = -r ;
    y = 0 ; 
    err = 2 - 2*r ;
    do {
        TFT_vline(x0-x, y0-y, y0+y, color) ;
        TFT_vline(x0+x, y0-y, y0+y, color) ;
        e2 = err ;
        if (e2 <= y) {
            err += ++y * 2 + 1 ;
            if ((-x == y)&&(e2 <= x)) {
                e2 = 0 ;
            }
        }
        if (e2 > x) {
            err += ++x * 2 + 1 ;
        }
    } while(x <= 0) ;
    if (old_auto_up) {
        auto_up = 1 ;
        // copy_to_lcd() ;
    }
}

void TFT_hline(int x0, int x1, int y, unsigned short color) 
{
    int len ;
    len = x1 - x0 + 1 ;
    TFT_window(x0, y, len, 1) ;
    TFT_window_pushpixelN(color, len) ;
    if (auto_up) { /* copy_to_lcd() ; */ }
    return ;
}

void TFT_vline(int x, int y0, int y1, unsigned short color) 
{
    int len ;
    len = y1 - y0 + 1 ;
    TFT_window(x, y0, 1, len) ;
    TFT_window_pushpixelN(color, len) ;
    if (auto_up) { /* copy_to_lcd() ; */ }
    return ;
}

void TFT_line(int x0, int y0, int x1, int y1, unsigned short color) 
{
    int dx = 0 ;
    int dy = 0 ;
    int dx_sym = 0 ;
    int dy_sym = 0 ;
    int dx_x2 = 0 ;
    int dy_x2 = 0 ;
    int di = 0 ;
    dx = x1-x0 ;
    dy = y1-y0 ;
    
    if (dx == 0) { /* vertical line */
        if(y1 < y0) SWAP(y0, y1) ;
        TFT_vline(x0, y0, y1, color) ;
        return ;
    }
    if (dx > 0) {
        dx_sym = 1 ;
    } else {
        dx_sym = -1 ;
    }
    if (dy == 0) { /* horizontal line */
        if (x1 < x0) SWAP(x1, x0) ;
        TFT_hline(x0, x1, y0, color) ;
        return ;
    }
    if (dy > 0) {
        dy_sym = 1 ;
    } else {
        dy_sym = -1 ;
    }
    dx = dx_sym*dx ;
    dy = dy_sym*dy ;
    dx_x2 = dx * 2 ;
    dy_x2 = dy * 2 ;
    
    if (dx >= dy) {
        di = dy_x2 - dx ;
        while(x0 != x1) {
            TFT_pixel(x0, y0, color) ;
            x0 += dx_sym ;
            if (di < 0) {
                di += dx_x2 ;
            } else {
                di += dy_x2 - dx_x2 ;
                y0 += dy_sym ;
            }
        }
        TFT_pixel(x0, y0, color) ;
    } else {
        di = dx_x2 - dy ;
        while (y0 != y1) {
            TFT_pixel(x0, y0, color) ;
            y0 += dy_sym ;
            if (di < 0) {
                di += dx_x2 ;
            } else {
                di += dx_x2 - dy_x2 ;
                x0 += dx_sym ; 
            }
        }
        TFT_pixel(x0, y0, color) ;
    }
    if (auto_up) { /* copy_to_led() ; */ }
    return ;    
}

void TFT_rect(int x0, int y0, int x1, int y1, unsigned short color) 
{
    int old_auto_up ;
    old_auto_up = auto_up ;
    if (old_auto_up) { auto_up = 0 ; }
    if (x1 > x0) TFT_hline(x0, x1, y0, color) ;
    else TFT_hline(x1, x0, y0, color ) ;
    
    if (y1 > y0) TFT_vline(x0, y0, y1, color) ;
    else TFT_vline(x0, y1, y0, color) ;
    
    if (x1 > x0) TFT_hline(x0, x1, y1, color) ;
    else TFT_hline(x1, x0, y1, color) ;
    
    if (y1 > y0) TFT_vline(x1, y0, y1, color) ;
    else TFT_vline(x1, y1, y0, color) ;
    
    if (old_auto_up) {
        auto_up = 1 ;
        // copy_to_lcd() ;
    }
    return ;
}

void TFT_fillrect(int x0, int y0, int x1, int y1, unsigned short color) 
{
    int h, w ;
    unsigned int pixels ;
    if (x0 > x1) SWAP(x0, x1) ;
    if (y0 > y1) SWAP(y0, y1) ;
    h = y1 - y0 + 1 ;
    w = x1 - x0 + 1 ;
    pixels = h * w ;
    TFT_window(x0,y0,w,h) ;
    TFT_window_pushpixelN(color, pixels) ;
    if (auto_up) { /* copy_to_lcd() ; */ }
    return ;
}

void TFT_locate(int x, int y) 
{
    char_x = x ;
    char_y = y ;
}

int TFT_putc(int value)
{
    if (value == '\n') { // new line
        char_x = 0 ;
        char_y = char_y + fontvert*fontzoomver ;
        if (char_y >= oriented_height - fontvert*fontzoomver) {
            char_y = 0 ;
        }
    } else {
        TFT_character(char_x, char_y, value) ;
        if (auto_up) { /* copy_to_lcd() ; */ }
    }
    return value ;
}

void TFT_character(int x, int y, int c) 
{
    int i, j, b ;
    unsigned char *zeichen ;
    unsigned char w, v, z ;
    
    char_x = x ;
    char_y = y ;
    if (char_x + fonthor*fontzoomhor > oriented_width) {
        char_x = 0 ;
        char_y = char_y + fontvert*fontzoomver ;
        if (char_y > oriented_height - fontvert*fontzoomver) {
            char_y = 0 ;
        }
    }
    TFT_window(char_x, char_y, fonthor*fontzoomhor, fontvert*fontzoomver) ; // char box
    if ((c < firstch)||(c > lastch)) { // test char range - if not exit fill with blank
        TFT_window_pushpixelN(_background, fontzoomhor) ; 
        w = fonthor ;
    } else {
        zeichen = &font[((c-firstch) * fontoffset) + 4] ; // start of char bitmap
        w = zeichen[0] ;
        // construct the char into the buffer
        for (j = 0 ; j < fontvert ; j++ ) { // vert line
            for (v = 0 ; v < fontzoomver ; v++ ) { // repeat horizontal line for vertical zooming
                for (i = 0 ; i < fonthor ; i++ ) {
                    z = zeichen[(fontbpl * i) + ((j & 0xF8) >> 3) + 1] ;
                    b = 1 << (j & 0x07) ;
                    if ((z & b) == 0x00) {
                        TFT_window_pushpixelN(_background, fontzoomhor) ; 
                    } else {
                        TFT_window_pushpixelN(_foreground, fontzoomhor) ;
                    }
                }
            }
        }
    }
    if (fontprop) { // in case the font if proportional
        if ((w+1) < fonthor) { 
            char_x += (w * fontzoomhor) + 1 ; // put at least 1 blank after variable-width charcter
        } else {
            char_x += fonthor * fontzoomhor ;
        }
    } else { // the font is fixed width
        char_x += fonthor * fontzoomhor ;
    }
}

void TFT_putstr(char *str) 
{
    while(*str) {
        TFT_putc(*str++) ;
    }
}

#if 0
void TFT_Bitmap_BW(Bitmap_s bm, int x, int y) 
{
    int h, v, b ;
    int cropX ;
    char d ;
    if (x < 0) x = 0 ;
    if (y < 0) y = 0 ;
    cropX = (x+bm.xSize)-oriented_width;
    if(cropX<0) cropX=0; 
    TFT_window(x, y, bm.xSize-cropX, bm.ySize);
    for(v=0; v < bm.ySize; v++) {   // lines
        if((v + y) >= oriented_height) break; // no need to crop Y
        for(h=0; h < bm.xSize; h++) { // pixel
            if((h + x) >= oriented_width) break;
            d = bm.data[bm.Byte_in_Line * v + ((h & 0xF8) >> 3)];
            b = 0x80 >> (h & 0x07);
            if((d & b) == 0) {
                TFT_window_pushpixel(_background);
            } else {
                TFT_window_pushpixel(_foreground);
            }
        }
    }
    if(auto_up) { /* copy_to_lcd(); */ }  
}
#endif

void TFT_Bitmap(int x, int y, int w, int h, unsigned char *bitmap) 
{
    int  j;
    int cropX, cropY ;
    unsigned char  padd;
    unsigned short *bitmap_ptr ;    

    bitmap_ptr = (unsigned short *)bitmap;    
    padd = w % 2 ; // the lines are padded to multiple of 4 bytes in a bitmap
    if(x<0) { 
        x=0 ;
    } else if(x>=oriented_width) {
        return ;
    }
    if(y<0) {
        y=0;
    } else if(y>=oriented_height) {
        return;
    }
    cropX = (x+w)-oriented_width;
    if(cropX < 0) {
        cropX = 0 ;
    }
    cropY = (y+h)-oriented_height;
    if(cropY < 0) {
        cropY = 0 ;
    }
    TFT_window(x, y, w-cropX, h-cropY);
    bitmap_ptr += ((h - 1)* (w + padd)); // begin of last line in array (first line of image)(standard bmp scan direction is left->right bottom->top)
    for (j = 0; j < h-cropY; j++) {         //Lines
        TFT_window_pushpixelbuf(bitmap_ptr, w-cropX);
        bitmap_ptr -= w+padd;
    }
    if(auto_up) { /* copy_to_lcd(); */ }    
}

#if 0
int  TFT_BMP_16(int x, int y, const char *Name_BMP) 
{

#define OffsetPixelWidth    18
#define OffsetPixelHeigh    22
#define OffsetFileSize      34
#define OffsetPixData       10
#define OffsetBPP           28

    char filename[50];
    unsigned char BMP_Header[54];
    unsigned short BPP_t;
    unsigned int PixelWidth,PixelHeigh,start_data;
    unsigned int    i,off;
    int padd,j;
    unsigned short *line;

    // get the filename
    i=0;
    while (*Name_BMP!='\0') {
        filename[i++]=*Name_BMP++;
    }
    filename[i] = 0;  
    
    FILE *Image = fopen((const char *)&filename[0], "rb");  // open the bmp file
    if (!Image) {
        return(0);      // error file not found !
    }

    fread(&BMP_Header[0],1,54,Image);      // get the BMP Header

    if (BMP_Header[0] != 0x42 || BMP_Header[1] != 0x4D) {  // check magic byte
        fclose(Image);
        return(-1);     // error no BMP file
    }

    BPP_t = BMP_Header[OffsetBPP] + (BMP_Header[OffsetBPP + 1] << 8);
    if (BPP_t != 0x0010) {
        fclose(Image);
        return(-2);     // error no 16 bit BMP
    }

    PixelHeigh = BMP_Header[OffsetPixelHeigh] + (BMP_Header[OffsetPixelHeigh + 1] << 8) + (BMP_Header[OffsetPixelHeigh + 2] << 16) + (BMP_Header[OffsetPixelHeigh + 3] << 24);
    PixelWidth = BMP_Header[OffsetPixelWidth] + (BMP_Header[OffsetPixelWidth + 1] << 8) + (BMP_Header[OffsetPixelWidth + 2] << 16) + (BMP_Header[OffsetPixelWidth + 3] << 24);
    if (PixelHeigh > oriented_height + y || PixelWidth > oriented_width + x) {
        fclose(Image);
        return(-3);      // to big
    }

    start_data = BMP_Header[OffsetPixData] + (BMP_Header[OffsetPixData + 1] << 8) + (BMP_Header[OffsetPixData + 2] << 16) + (BMP_Header[OffsetPixData + 3] << 24);

    line = (unsigned short *) malloc (2 * PixelWidth); // we need a buffer for a line
    if (line == NULL) {
        return(-4);         // error no memory
    }

    // the bmp lines are padded to multiple of 4 bytes
    padd = -1;
    do {
        padd ++;
    } while ((PixelWidth * 2 + padd)%4 != 0);

    window(x, y,PixelWidth ,PixelHeigh);
//    wr_cmd(0x2C);  // send pixel
    for (j = PixelHeigh - 1; j >= 0; j--) {               //Lines bottom up
        off = j * (PixelWidth  * 2 + padd) + start_data;   // start of line
        fseek(Image, off ,SEEK_SET);
        fread(line,1,PixelWidth * 2,Image);       // read a line - slow 
  /*      for (i = 0; i < PixelWidth; i++)
        {        // copy pixel data to TFT
     //       wr_16(line[i]);                  // one 16 bit pixel   
            window_pushpixel(line[i]);
            
        } */
        window_pushpixelbuf(line, PixelWidth);
     }
    free (line);
    fclose(Image);
    if(auto_up) copy_to_lcd();
    return(1);    
}
#endif

void TFT_set_font(const unsigned char* f) 
{
    font = f ;
    // fontoffset = font[0] ;       // bytes / char
    fonthor = font[1] ;             // get hor size of font
    fontvert = font[2] ;            // get vert size of font
    // fontbpl = font[3] ;          // bytes per line
    fontbpl = (fontvert+7)>>3 ;     // bytes per line, rounded up to multiple of 8
    fontoffset = (fonthor*fontbpl)+1 ; 
    firstch = 32 ;
    lastch = 127 ;
    fontprop = 1 ; /* 1: proportional 0: fixed */
    TFT_set_font_zoom(1, 1) ;
}

unsigned char TFT_font_width(void)
{
    return(fonthor) ;
}

unsigned char TFT_font_height(void)
{
    return(fontvert) ;
}

int  TFT_columns() 
{
    return oriented_width / fonthor ;
}

int  TFT_rows() 
{
    return oriented_height / fontvert ;
}

void TFT_set_auto_up(int up) 
{
    auto_up = up ;
}

int  TFT_get_auto_up(void) 
{
    return auto_up ;
}

void TFT_set_font_zoom(unsigned char x_mul, unsigned char y_mul) 
{
    fontzoomhor = ((x_mul==0) ? 1:x_mul) ;
    fontzoomver = ((y_mul==0) ? 1:y_mul) ;
}

void TFT_set_font_proportional(int isProportional) 
{
    fontprop = isProportional ;
}

int  TFT_get_font_proportional(void) 
{
    return fontprop ;
}
/* [] END OF FILE */
