/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#ifndef _TFT_H_
#define _TFT_H_
#include "project.h"
    
/** Bitmap
 */
struct Bitmap_s{
    int xSize;
    int ySize;
    int Byte_in_Line;
    char* data;
};
    
void TFT_Init(void) ;
void TFT_BackLight(int mode) ; /* 0: off 1: on */
void TFT_BusEnable(int mode) ;
void TFT_window(int x, int y, int w, int h) ;
void TFT_pixel(int x, int y, unsigned short color) ;
void TFT_WindowMax(void) ;
void TFT_window_pushpixel(unsigned short color) ;
void TFT_window_pushpixelN(unsigned short color, unsigned int count) ;
void TFT_cls(void) ;
void TFT_set_orientation(int orientation) ;
void TFT_FastWindow(int mode) ;
int  TFT_sizeX(void) ;
int  TFT_sizeY(void) ;
int  TFT_width() ;
int  TFT_height() ;
void TFT_foreground(unsigned short fg) ;
unsigned short TFT_get_foreground(void) ;
void TFT_background(unsigned short bg) ;
unsigned short TFT_get_background(void) ;
void TFT_circle(int x, int y, int r, unsigned short color) ;
void TFT_fillcircle(int x, int y, int r, unsigned short color) ;
void TFT_line(int x0, int y0, int x1, int y1, unsigned short color) ;
void TFT_hline(int x0, int x1, int y, unsigned short color) ;
void TFT_vline(int x, int y0, int y1, unsigned short color) ;
void TFT_rect(int x0, int y0, int x1, int y1, unsigned short color) ;
void TFT_fillrect(int x0, int y0, int x1, int y1, unsigned short color) ;
void TFT_locate(int x, int y) ;
int  TFT_putc(int value) ;
void TFT_character(int x, int y, int c) ;
void TFT_putstr(char *str) ;
void TFT_Bitmap(int x, int y, int w, int h, unsigned char *bitmap) ;
// void TFT_Bitmap_BW(Bitmap_s bm, int x, int y) ;
// int  TFT_BMP_16(int x, int y, const char *Name_BMP) ;
void TFT_set_font(const unsigned char* f ) ;
unsigned char TFT_font_width(void) ;
unsigned char TFT_font_height(void) ;

#if 0 
    , 
    unsigned char firstascii=32, 
    unsigned char lastascii=127, 
    int proportional = 1);
#endif
int  TFT_columns() ;
int  TFT_rows() ;
void TFT_set_auto_up(int up) ;
int  TFT_get_auto_up(void) ;

void TFT_set_font_zoom(unsigned char x_mul, unsigned char y_mul) ;
void TFT_set_font_proportional(int isProportional) ;
int  TFT_get_font_proportional(void) ;

/* some RGB color definitions                                                 */
#define Black           0x0000      /*   0,   0,   0 */
#define Navy            0x000F      /*   0,   0, 128 */
#define DarkGreen       0x03E0      /*   0, 128,   0 */
#define DarkCyan        0x03EF      /*   0, 128, 128 */
#define Maroon          0x7800      /* 128,   0,   0 */
#define Purple          0x780F      /* 128,   0, 128 */
#define Olive           0x7BE0      /* 128, 128,   0 */
#define LightGrey       0xC618      /* 192, 192, 192 */
#define DarkGrey        0x7BEF      /* 128, 128, 128 */
#define Blue            0x001F      /*   0,   0, 255 */
#define Green           0x07E0      /*   0, 255,   0 */
#define Cyan            0x07FF      /*   0, 255, 255 */
#define Red             0xF800      /* 255,   0,   0 */
#define Magenta         0xF81F      /* 255,   0, 255 */
#define Yellow          0xFFE0      /* 255, 255,   0 */
#define White           0xFFFF      /* 255, 255, 255 */
#define Orange          0xFD20      /* 255, 165,   0 */
#define GreenYellow     0xAFE5      /* 173, 255,  47 */
    
#endif /* _TFT_H_ */
/* [] END OF FILE */
